# Script: GreetWondeR
# Version: 1.5
# Required: Eggdrop 1.3.x
# Author:  Wingman <Wingman@Defiant.vilstal.net>
#          http://defiant.vilstal.net/~wingman/
# Please send _any_ suggestions and bugreports to: greetwonder@gmx.net

# For more informations, view: greetwonder.readme
# For settings, edit greetwonder.conf

# if {[you are not familiar with tcl]} { 
#   putlog "STOP READING" ; return 0
#   } {
#   putlog "Change anything below - but send a mail with .diff ;)"
#   }

set greet(version) "1.5"

if {![info exists numversion] || ($numversion < 1030000)} { 
  if {[string range $version 0 2] != "1.3"} { 
    putlog "TCL: GreetWondeR $greet(version) Warning: This tcl was written and tested with Eggdrop 1.3.x. If an error occurs, pls send a mail to Wingman@Defiant.vilstal.net." 
    } 
  } 

if {![file exists scripts/greetwonder.conf]} { 
  putlog "GreetWondeR $greet(version) ERROR: Can't find greetwonder.conf, copy it to: ./scripts" 
  return 0
  }

set file [open scripts/greetwonder.conf r]
while {![eof $file]} {
  set line [gets $file]
  if {[string match "set *" $line]} { 
    set [lindex $line 1] "[string trim [lindex $line 2] \"]"
    }
  if {[string match "# You didn't edit your config file*" $line]} { 
    putlog "GreetWondeR $greet(version) WARNING: You didn't edit your config file, eh? :)"
    }
  }  
close $file

proc greet:putlog { string } {
global version
putcmdlog $string
}

proc greet:flag2norm { what flag } {
if {[string match "+?" $flag]} {
  set flag [string trimleft $flag +]
  }
if {[lsearch -exact [split "hmnpxtjcubdnofkvqspgalri" ""] $flag] == -1} {
  return "$flag" 
  }
if {[string tolower $what] == "user"} {
  switch -exact $flag {
    "h" { set ret "high-light flag" }
    "m" { set ret "master" }
    "p" { set ret "party-line" }
    "x" { set ret "xfer" }
    "t" { set ret "botnet-master" }
    "j" { set ret "janitor" }
    "c" { set ret "common" }
    "u" { set ret "unshared" }
    "b" { set ret "bot" }
    "d" { set ret "deop" }
    "n" { set ret "owner" }
    "o" { set ret "op" }
    "f" { set ret "friend" }
    "k" { set ret "auto-kick" }
    "v" { set ret "voice" }
    "q" { set ret "quit" }
    "a" { set ret "auto-op" }
    "w" { set ret "wasop-test" }
    }
  }
if {[string tolower $what] == "bot"} {
  switch -exact $flag {
    "s" { set ret "share (aggressively)" }
    "p" { set ret "share (passively)" }
    "g" { set ret "global share" }
    "h" { set ret "hub" }
    "a" { set ret "alternate hub" }
    "l" { set ret "leaf" }
    "r" { set ret "reject" }
    "i" { set ret "isolate" }
    "b" { set ret "bot" }
    }
  }
if {![info exists ret]} { return "$flag" } { return "$ret" }
}  

proc greet:ispermown { handle } {
global owner
if {$handle == "*"} { return 0 }
foreach zowner [split [string trim $owner " "] ,] { 
if {[string tolower $handle] == [string tolower $zowner]} { set isowner 1 } }
if {[info exists isowner]} { 
  if {[matchattr $handle n]} { 
    return 1 
    } { 
    return 0
    }
  }
return 0
}  

proc greet:sl { string } {
foreach var $string {
  if {![info exists cl]} {
    set cl [string length $var]
    } {
    set cl2 [string length $var]
    if {$cl2 > $cl} { set cl $cl2 }
    }
  }
return $cl
}

proc stl { string } {
return [string tolower $string]
}

proc greet:lend { start string } {
set count 0
foreach word $string {
  incr count
  if {$count > $start} { if {![info exists result]} { set result $word } { append result " $word" } } }
if {![info exists result]} { return "" } { return "$result" }
}

proc greet:load { varname } {
global greet
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line "[gets $file]"
    if {"[stl [lindex $line 0]]" == "$varname"} {
      set ret "[greet:lend 2 $line]"
      close $file
      return "$ret"
      }
    }
close $file
return "" 
}

proc greet:save { name value } {
global greet 
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line [gets $file]
  if {[lindex $line 0] != $name} { 
    lappend datalist $line 
    }
  }
close $file
set file [open $greet(dir)/$greet(data) w]
foreach line $datalist {
  if {$line != ""} {
    puts $file $line
    }
  }
puts $file "$name = $value"
close $file
return 1
}

proc greet:getchannels {} {
global chanfile
set file [open $chanfile r]
while {![eof $file]} {
  set line [gets $file]
  if {($line != "") && (![string match "#*" $line])} {
    if {![info exists channels]} { set channels "[lindex $line 2]" } { append channels " [lindex $line 2]" } } }
close $file
if {![info exists channels]} { return "" } { return "$channels" }
}    

proc greet:getfile { file } {
if {![file exists $file]} { return "" }
set file2read [open $file r]
while {![eof $file2read]} {
 set line "[gets $file2read]"
 if {$line != ""} { lappend inhalt $line } }
close $file2read
if {![info exists inhalt]} { return "" } { return "$inhalt" }
}

proc greet:setxtra { handle what } {
setuser $handle XTRA wgreet $what
}

proc greet:getxtra { handle } {
set xtra [getuser $handle XTRA]
foreach string $xtra {
  if {[string match "wgreet *" $string]} { if {![info exists ret]} { set ret [lrange $string 1 end] } { append ret " [lrange $string 1 end]" } } }
if {![info exists ret]} { return "" } { return "$ret" }
}

proc greet:putinit { what idx string } {
if {$what == "start"} { putlog "$string" } { putdcc $idx "$string" } 
}

proc greet:init { what idx } {
global nickgreets changreets greet hostgreets greethow greetall greetrandom
if {![file exists $greet(dir)]} {
  exec mkdir $greet(dir)
  exec mkdir $greet(dir)/channels
  foreach chan [greet:getchannels] {
    set cfilename [stl [string trimleft $chan #]]
    set file [open $greet(dir)/channels/${cfilename}.dat w]
    close $file
    set file [open $greet(dir)/channels/${cfilename}.dat w]
    close $file
    if {![info exists channels_created]} { set channels_created $chan } { append channels_created ", $chan" }
    }
  set file [open $greet(dir)/$greet(data) w]
  puts $file "# TCL: GreetWondeR $greet(version)"
  puts $file "# This file was created on [date] at [time]."
  puts $file "greet(how) = $greet(how)"
  puts $file "greet(all) = $greet(all)"
  foreach chan [greet:getchannels] {
    set chan [stl $chan]
    puts $file "greet($chan) = 1"
    puts $file "greetall($chan) = $greet(all)"
    puts $file "greethow($chan) = $greet(how)"
    }
  close $file
  set file [open $greet(dir)/$greet(nicks) w]
  close $file
  greet:putinit $what $idx "-----------"
  greet:putinit $what $idx "GreetWondeR $greet(version) - Starting Setup Sequence."
  greet:putinit $what $idx " "
  greet:putinit $what $idx "  Created directory: $greet(dir)"
  if {[info exists channels_created]} { 
    greet:putinit $what $idx "  Created channelfile(s): $channels_created"
    }
  greet:putinit $what $idx "  Created datafile: $greet(data)"
  greet:putinit $what $idx "  Created nickfile: $greet(nicks)"
  if {[file exists scripts/greetwonder.help]} {
    greet:putinit $what $idx "  Found helpfile in: scripts/greetwonder.help"
    } {
    greet:putinit $what $idx "  Warning: Can't find scripts/greetwonder.help"
    }
  if {[file exists scripts/greetwonder.conf]} {
    greet:putinit $what $idx "  Found conffile in: scripts/greetwonder.conf"
    } {
    greet:putinit $what $idx "  Warning: Can't find scripts/greetwonder.conf"
    }
  if {$greet(floodprotect) == 1} {
    greet:putinit $what $idx " "
    greet:putinit $what $idx "  Flood Protection enabled."
    greet:putinit $what $idx "    Flood settings:"
    set cl [greet:sl [channels]]
    greet:putinit $what $idx "      [format "%-${cl}s   %5s   %1s" Channel Joins Secs]"
    foreach chan [channels] {
      set joins [lindex [split [lindex [channel info $chan] 9] :] 0]
      set secs [lindex [split [lindex [channel info $chan] 9] :] 1]
      if {$joins == 0 || $secs == 0} {
        if {![info exists cwofs]} { set cwofs $chan } { append cwofs ", $chan" }
	} {
        greet:putinit $what $idx "      [format "%-${cl}s   %-5s   %1s" $chan $joins $secs]" 
	}
      }
    if {[info exists cwofs]} {
      greet:putinit $what $idx " "
      greet:putinit $what $idx "    Channels with no flood settings:"
      greet:putinit $what $idx "    $cwofs"
      greet:putinit $what $idx "  (use .chanset <chan> flood-join <joins>:<secs>)"
      }
    }
  greet:putinit $what $idx " "
  greet:putinit $what $idx "GreetWonder $greet(version) - Setup complete."
  greet:putinit $what $idx "-----------"
  }
if {![file exists $greet(dir)/$greet(data)]} {
  set file [open $greet(dir)/$greet(data) w]
  puts $file "# TCL: GreetWondeR $greet(version)"
  puts $file "# This file was created on [date] at [time]."
  puts $file "greet(how) = $greet(how)"
  puts $file "greet(all) = $greet(all)"
  foreach chan [greet:getchannels] {
    set chan [stl $chan]
    puts $file "greet($chan) = 1"
    puts $file "greetall($chan) = $greet(all)"
    puts $file "greethow($chan) = $greet(how)"
    }
  close $file
  }
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line [gets $file]
  if {[string match "# TCL: GreetWondeR *" $line]} {
    set olddataver "[lindex $line 3]"
    }
  }
close $file 
if {![info exists olddataver]} { set olddataver "hacked" }
  if {"$greet(version)" != "$olddataver"} {
    greet:putinit $what $idx  "-----------"
    greet:putinit $what $idx  "GreetWondeR $greet(version) Starting Update Sequence."
    greet:putinit $what $idx  " "
    greet:putinit $what $idx  "  Found old version: $olddataver."
    set file [open $greet(dir)/$greet(data) r]
    while {![eof $file]} {
      set line [gets $file]
      if {![string match "#*" $line]} {
        lappend tmp $line
	}
      }
    close $file
    set file [open $greet(dir)/$greet(data) w]
    puts $file "# TCL: GreetWondeR $greet(version)"
    puts $file "# This file was created on [date] at [time]."
    foreach line $tmp {
      if {$line != ""} { puts $file $line }
      }
    close $file
    set publicver "1.0.0 1.0.1 1.0.2 1.0.3 1.0.4 1.0.4b 1.0.5 1.1 1.2 1.2+greet:joinfix 1.3 1.4 1.4.1 1.4.2 1.5 update"
    if {[lsearch -exact $publicver $olddataver] == -1} {
      greet:putinit $what $idx  " "
      greet:putinit $what $idx  "WARNING: Hacked old GreetWondeR Version found!"
      greet:putinit $what $idx  "         Deleting all greets and restarting..."
      greet:putinit $what $idx  "-----------"
      exec rm -rf $greet(dir)
      greet:init start - 
      return 0
      } {
      greet:putinit $what $idx "  Found old datafile: converted."
      if {![file exists $greet(dir)/channels]} {
        exec mkdir $greet(dir)/channels
	}
      foreach chan [greet:getchannels] {
        set ccount($chan) 0
        if {![file exists $greet(dir)/[stl [string trimleft $chan #]].dat]} {
	  if {![info exists tmp4]} { set tmp4 $chan } { append tmp4 ", $chan" }
	  } {
          set file [open $greet(dir)/[stl [string trimleft $chan #]].dat r]
	  while {![eof $file]} {
	    set line [gets $file]
            while {[string match "* (nick) *" $line] || [string match "* (nick)" $line] || [string match "(nick) *" $line]} {
              incr ccount($chan)
	      set found [lsearch -exact $line "(nick)"]
              set line [lreplace $line $found $found greet-nick]
              }
            while {[string match "* (chan) *" $line] || [string match "* (chan)" $line] || [string match "(chan) *" $line]} {
	      incr ccount($chan)
              set found [lsearch -exact $line "(chan)"]
              set line [lreplace $line $found $found greet-chan]
              }
            while {[string match "* (botnick) *" $line] || [string match "* (botnick)" $line] || [string match "(botnick) *" $line]} {
	      incr ccount($chan)
              set found [lsearch -exact $line "(botnick)"]
              set line [lreplace $line $found $found greet-botnick]
              }
	    if {$line != ""} { 
              lappend tmp2 $line
              }
	    }
          close $file
	  set file [open $greet(dir)/channels/[stl [string trimleft $chan #]].dat w]
          if {[info exists tmp2]} {
            foreach line $tmp2 {
	      puts $file $line
	      }
	    }  
	  close $file
          exec mv $greet(dir)/[stl [string trimleft $chan #]].dat $greet(dir)/channels/[stl [string trimleft $chan #]].old
	  }
	}
      greet:putinit $what $idx " " 
      if {[info exists tmp4] && [lsearch -exact "1.4 1.4.1 1.4.2 update" $olddataver] == "-1"} {
        greet:putinit $what $idx  "  Can't find old channelfile(s): $tmp4"
        greet:putinit $what $idx  " "
	}
      greet:putinit $what $idx "  Searching channelfiles for old formatings... (e.g. (nick)):"  
      foreach chan [greet:getchannels] {
        if {$ccount($chan) != 0} {
          set tmp5 1 
          greet:putinit $what $idx  "    $chan: $ccount($chan) word(s) converted"
          }
        }  
      if {![info exists tmp5]} { greet:putinit $what $idx "    No old formatings found." } 
      if {![file exists $greet(dir)/$greet(nicks)]} {
        set file [open $greet(dir)/$greet(nicks) w]
	close $file
	} {
        set ncount 0
	set file [open $greet(dir)/$greet(nicks) r]
        while {![eof $file]} {
          set line [gets $file]
          while {[string match "* (nick) *" $line] || [string match "* (nick)" $line] || [string match "(nick) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(nick)"]
            set line [lreplace $line $found $found greet-nick]
            }
          while {[string match "* (chan) *" $line] || [string match "* (chan)" $line] || [string match "(chan) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(chan)"]
            set line [lreplace $line $found $found greet-chan]
            }
          while {[string match "* (botnick) *" $line] || [string match "* (botnick)" $line] || [string match "(botnick) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(botnick)"]
            set line [lreplace $line $found $found greet-botnick]
            }
          if {$line != ""} { lappend tmp4 $line }
          }
        close $file
	set file [open $greet(dir)/$greet(nicks) w]
        if {[info exists tmp4]} {
          foreach line $tmp4 {
	    if {[llength $line] < 2} { puts $file $line } 
	    }  
          }
	close $file
        greet:putinit $what $idx  " "
	greet:putinit $what $idx  "  Searching nickfile for old formatings... (e.g. (chan)):"
        if {$ncount != 0} {
	  greet:putinit $what $idx  "    Found $ncount word(s) - converted"
	  } {
	  greet:putinit $what $idx  "    No old formatings found."
	  }
	}
      greet:putinit $what $idx  " "
      greet:putinit $what $idx  "GreetWondeR $greet(version) - Update complete."
      greet:putinit $what $idx  "-----------"
      }
    }
if {![file exists $greet(dir)/$greet(data)]} {
  set file [open $greet(dir)/$greet(data) w]
  puts $file "# TCL: GreetWondeR $greet(version)"
  puts $file "# This file was created on [date] at [time]."
  puts $file "greet(how) = $greet(how)"
  puts $file "greet(all) = $greet(all)"
  foreach chan [greet:getchannels] {
    set chan [stl $chan]
    puts $file "greet($chan) = 1"
    puts $file "greetall($chan) = $greet(all)"
    puts $file "greethow($chan) = $greet(how)"
    }
  close $file
  }
if {![file exists $greet(dir)/channels]} {
  exec mkdir $greet(dir)/channels
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  set file [open $greet(dir)/$greet(nicks) w]
  close $file
  }
foreach chan [greet:getchannels] {
  if {![file exists $greet(dir)/channels/[stl [string trimleft $chan #]].host]} {
    set file [open $greet(dir)/channels/[stl [string trimleft $chan #]].host w]
    close $file
    }
  if {![file exists $greet(dir)/channels/[stl [string trimleft $chan #]].dat]} {
    set file [open $greet(dir)/channels/[stl [string trimleft $chan #]].dat w]
    close $file
    }
  }  
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line [gets $file]
  if {[string match "greet(*" $line] || [string match "greetall(*" $line] || [string match "greethow(*" $line] || [string match "greetrand(*" $line]} {
    set [lindex $line 0] "[lindex $line 2]"
    }
  }
close $file  
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
foreach chan [greet:getchannels] {
  set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[stl [string trimleft $chan #]].dat]
  set hostgreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
  }
if {$greet(floodprotect) == 1} {
 bind flud -|- join greet:flood
 }
if {$what == "start"} { 
  putlog "GreetWondeR $greet(version) by Wingman loaded (.greethelp for help)."
  }
} 

proc greet:flood { nick uhost handle type chan } {
global greetflood greet
if {[info exists greetflood([stl $chan])]} { return 0 }
putlog "GreetWondeR $greet(version) - FLOOD JOINS detected on $chan: Shutting down greets for $chan."
timer $greet(noresponse) "greet:startup $chan"
set greetflood([stl $chan]) 1
return 0
}

proc greet:startup { chan } {
global greetflood greet
putlog "GreetWondeR $greet(version) - FLOOD JOINS on $chan seem to be over: Restarting greets for $chan."
if {[info exists greetflood([stl $chan])]} { unset greetflood([stl $chan]) }
}

bind dcc $greet(gbind) greetreset dcc:greetreset
bind dcc $greet(gbind) greetstatus dcc:greetstatus
bind dcc $greet(gbind) +greetfile dcc:+greetfile
bind dcc $greet(nbind) +greetnick dcc:+greetnick
bind dcc $greet(nbind) -greetnick dcc:-greetnick
bind dcc $greet(nbind) greetnickview dcc:greetnickview
bind dcc $greet(nbind) greet dcc:greet
bind dcc $greet(rbind) greetmove dcc:greetmove
bind dcc $greet(rbind) greetmv dcc:greetmove
bind dcc $greet(rbind) greetrandom dcc:greetrandom
bind dcc $greet(rbind) +greet dcc:+greet
bind dcc $greet(rbind) -greet dcc:-greet
bind dcc $greet(rbind) +greethost dcc:+greethost
bind dcc $greet(rbind) -greethost dcc:-greethost
bind dcc $greet(rbind) greethow dcc:greethow
bind dcc $greet(rbind) greetwho dcc:greetwho
bind dcc $greet(rbind) greetview dcc:greetview
bind dcc $greet(rbind) gmotd dcc:gmotd
bind dcc $greet(rbind) greethelp dcc:greethelp

bind chon n * motd:greet
proc motd:greet { handle idx } {
global greet
if {[greet:getxtra $handle] == 0} { return 0 }
putdcc $idx " "
putdcc $idx "This Bot is using GreetWondeR $greet(version)."
putdcc $idx "You are a global owner. Try .greethelp for a list of commands."
putdcc $idx "(to deactivate this message, try .gmotd off)"
putdcc $idx " "
}

proc dcc:gmotd { handle idx arg } {
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .gmotd <on/off>"
  return 0
  }
greet:putlog "#$handle# gmotd $arg"
set handle [stl $handle]
set arg [stl $arg]
if {$arg == "on"} {
  greet:setxtra $handle 1
  putdcc $idx "GreetWondeR MOTD turned on."
  return 1 
  }
if {$arg == "off"} {
  greet:setxtra $handle 0
  putdcc $idx "GreetWondeR MOTD turned off."
  return 1 
  }
putdcc $idx "Usage: .gmotd <on/off>"
}

proc dcc:greetreset { handle idx arg } {
global greet
greet:putlog "#$handle# greetreset"
putdcc $idx "Resetting GreetWondeR $greet(version)"
if {[file exists $greet(dir)]} {
  exec rm -rf $greet(dir)
  }
greet:init reset $idx 
putdcc $idx "Done, GreetWondeR $greet(version) successfully resetted."
return 1
}

proc dcc:greetstatus { handle idx arg } {
global greet nickgreets greetflood
switch -exact $greet(all) {
  "0" { set a "unknown" } 
  "1" { set a "all" }
  "2" { set a "known" }
  }
greet:putlog "#$handle# greetstatus"
putdcc $idx "I am GreetWondeR.tcl, running Version $greet(version)."
if {![file exists $greet(dir)/$greet(nicks)]} {
  set nsize 0
  } else {
  set nsize [file size $greet(dir)/$greet(nicks)]
  }
set greethow [greet:load greet(how)]
putdcc $idx " "
putdcc $idx "FILE SETTINGS:"
putdcc $idx "  Data is saved in $greet(dir)/$greet(data) ([file size $greet(dir)/$greet(data)] bytes)"
putdcc $idx "  Nick-greets are saved in $greet(dir)/$greet(nicks) ($nsize bytes)"
putdcc $idx " "
putdcc $idx "GLOBAL SETTINGS:"
putdcc $idx "  Greeting $a users via $greethow ($greet(max) lines allowed for greets)."
if {$greet(delay) == 0} {
  putdcc $idx "  Greet delay is disabled."
  } { 
  putdcc $idx "  Greet delay is set to $greet(delay) seconds."
  }
set cl [greet:sl [channels]]
if {$greet(floodprotect) == 1 && [stl [lindex $arg 0]] == "flood"} {
  putdcc $idx " "
  putdcc $idx "FLOOD SETTINGS:"
  putdcc $idx "  Shutdown for $greet(noresponse) mins on flood-join attack"
  putdcc $idx "    [format "%-${cl}s   %5s   %1s" Channel Joins Secs]"
  foreach chanz [channels] {
    set joins "[lindex [split [lindex [channel info $chanz] 9] :] 0]"
    set secs "[lindex [split [lindex [channel info $chanz] 9] :] 1]"
    if {$joins == 0 || $secs == 0} { 
      if {![info exists nfchan]} { set nfchan $chanz } { append nfchan ", $chanz" }
      } {
      putdcc $idx "    [format "%-${cl}s   %-5s   %1s" $chanz $joins $secs]"
      }
    if {[info exists greetflood([stl $chanz])]} {
      putdcc $idx "      WARNING: FLOOD JOINS on $chanz: Greets are disabled."
      }
    }
  if {[info exists nfchan]} {
    putdcc $idx " "
    putdcc $idx "  Channels with no flood-join settings:"
    putdcc $idx "    $nfchan"
    putdcc $idx "    (use: .chanset <channel> flood-chan <joins>:<secs>)"
    }
  }
set count 0
putdcc $idx " "
putdcc $idx "GREETS:"
set file [open $greet(dir)/$greet(nicks) r]
while {![eof $file]} {
  set line [gets $file]
  if {[llength $line] > 1} {
    incr count
    }
  }
close $file
if {$count == 1} {
  putdcc $idx "  Nick-greets: There is currently 1 nick-greet saved."
  } elseif {$count == 0} {
  putdcc $idx "  Nick-greets: There are currently no nick-greets saved."
  } {
  putdcc $idx "  Nick-greets: There are currently $count nick-greets saved."
  }
putdcc $idx "  Chan- and hostgreets:"
putdcc $idx "    [format "%-${cl}s   %-7s   %-4s  %-4s" Channel Who Lines Hosts]  On/Off" 
foreach chan [greet:getchannels] {
  set chan [stl $chan]
  set greetload "$greet(dir)/channels/[stl [string trimleft $chan #]].dat"
  if {![file exists $greetload]} {
    set file [open $greetload w]
    close $file
    }
  set count 0
  set file [open $greetload r]
  while {![eof $file]} {
    set line [gets $file]
    if {$line != ""} {
      incr count
      }
    }
  close $file
  set greetall [greet:load greetall([stl $chan])]
  if {[greet:load greet([stl $chan])] == 1} { 
    set b "on" 
    } else { 
    set b "off"
    } 
  switch -exact $greetall {
    "1" { set c "all" }
    "0" { set c "known" }
    "2" { set c "unknown" }
    }
  set hcount 0
  set hfile [greet:getfile $greet(dir)/channels/[stl [string trimleft $chan #]].host]
  foreach line $hfile { incr hcount }
  if {$count == 0 && $hcount == 0} {
    if {![info exists tmp1]} { set tmp1 "$chan" } { append tmp1 ", $chan" }
    } {
    putdcc $idx "    [format "%-${cl}s   %-7s   %-4s   %-5s  %-2s" $chan $c $count $hcount $b]"
    if {[info exists greetflood([stl $chan])]} {
      putdcc $idx "       WARNING: There were FLOOD JOINS on $chan: Greets are disabled."
      }
    }
  }
if {[info exists tmp1]} {
  if {[llength $tmp1] == [llength [greet:getchannels]]} {
    putdcc $idx "    [format "%-${cl}s   %-7s   %-4s   %-5s  %-2s" - - - - -]"
    putdcc $idx " "
    putdcc $idx "  There are currently no chan- or hostgreets saved!"
    } {
    putdcc $idx " "
    putdcc $idx "  Channel(s) with no chan- or hostgreets: $tmp1"
    putdcc $idx "  (use '.greetview #channel' to view the greets)"
    }
  }  
return 1
} 

proc dcc:+greetnick { handle idx arg } {
global greet nickgreets
if {[llength $arg] < 3} {
  putdcc $idx "Usage: .+greetnick <handle> <msg/notice/pub/act> <text>"
  return 0
  }
set nick [lindex $arg 0]
set how [stl [lindex $arg 1]]
switch -exact $how {
  "msg"    { set how "PRIVMSG" ; set tmp 1 }
  "notice" { set how "NOTICE " ; set tmp 1 }
  "pub"    { set how "PUBLIC"  ; set tmp 1 }
  "act"    { set how "ACTION"  ; set tmp 1 }
  }
if {![info exists tmp]} { 
  putdcc $idx "ERROR: Don't know, how to greet via $how."
  return 0
  }
set text [greet:lend 2 $arg]
if {![validuser $nick]} {
  putdcc $idx "I don`t know $nick. Only nicks, which are in the userlist, are allowed!"
  return 0
  }  
if {$text == ""} {
  putdcc $idx "Usage: .+greetnick <handle> <msg/notice/pub/act> <text>"
  return 0
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  set file [open $greet(dir)/$greet(nicks) w]
  puts $file "$nick $how $text"
  close $file
  } else {
  set fileindex [greet:getfile $greet(dir)/$greet(nicks)]
  foreach line $fileindex {  
    if {[llength $line] > 1} {
      if {[string match "$nick" [lindex $line 0]]} {
        putdcc $idx "Already a greetline for $nick: [greet:lend 2 $line] via [lindex $line 1]"
	return 0
	}
      }
    }
  set file [open $greet(dir)/$greet(nicks) a+]
  puts $file "$nick $how $text"
  close $file
  }
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
greet:putlog "#$handle# +greetnick $nick $how $text"
putdcc $idx "Now greeting $nick with \"$text\" via $how."
return 1
}

proc dcc:-greetnick { handle idx arg } {
global greet nickgreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .-greetnick <nick>"
  return 0
  }
set nick [lindex $arg 0]
if {![validuser $nick]} {
  putdcc $idx "I don`t know $nick. Only nicks, which are in the userlist, are allowed."
  return 0
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  putdcc $idx "No nick greets are saved."
  return 0
  }
greet:putlog "#$handle# -greetnick $arg"
set tmp [greet:getfile $greet(dir)/$greet(nicks)]
set file [open $greet(dir)/$greet(nicks) w]
foreach line $tmp {
  if {$line != ""} {
    if {![string match "$nick *" $line]} {
      puts $file $line
      }
    }
  }
close $file
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
greet:putlog "#$handle# -greetnick $nick"
putdcc $idx "Deleted greet for $nick."
return 1
}

proc greet:gethelp { what } {
global greet
if {![file exists scripts/greetwonder.help]} {
  return "{ERROR: Can't find scripts/greetwonder.help}"
  }
set file [open scripts/greetwonder.help r]
set lcount 0
while {![eof $file]} {
  set line [gets $file]
  if {[info exists count]} {
    incr lcount
    if {$lcount <= $count} {
      lappend help $line
      }
    }
  if {[string match "$what *" $line]} {
    set count [lindex $line 1]
    }
  }
close $file
return "$help"
}

proc dcc:greethelp { handle idx arg } {
global greet
set arg "[stl $arg]"
set gflag1 [greet:flag2norm user [lindex [split $greet(gbind) |] 0]]
set cflag1 [greet:flag2norm user [lindex [split $greet(gbind) |] 1]]
set gflag2 [greet:flag2norm user [lindex [split $greet(nbind) |] 0]]
set cflag2 [greet:flag2norm user [lindex [split $greet(nbind) |] 1]]
set gflag3 [greet:flag2norm user [lindex [split $greet(rbind) |] 0]]
set cflag3 [greet:flag2norm user [lindex [split $greet(rbind) |] 1]]
if {[llength $arg] < 1} {
  putdcc $idx "DCC COMMANDS for TCL: GreetWondeR $greet(version)"
  putdcc $idx " "
  if {"$cflag1" == "-"} {
    putdcc $idx "  For global $gflag1:"
    } {
    putdcc $idx "  For global $gflag1 and chan$cflag1:"
    }
  putdcc $idx "    +greetfile     greetreset        greetstatus"
  putdcc $idx " "
  if {"$cflag2" == "-"} {
    putdcc $idx "  For global $gflag2:"
    } {
    putdcc $idx "  For global $gflag2 and chan$cflag2:"
    }
  putdcc $idx "    +greetnick     greetnickview     greet"
  putdcc $idx "    -greetnick"
  putdcc $idx " "
  if {"$cflag3" == "-"} {
    putdcc $idx "  For global $gflag3:"
    } {
    putdcc $idx "  For global $gflag3 and chan$cflag3:"
    }
  putdcc $idx "    +greet         +greethost        greetwho"
  putdcc $idx "    -greet         -greethost        greethow"
  putdcc $idx "    greetmove      greetview         gmotd"
  putdcc $idx "    greetrandom"
  putdcc $idx " "
  putdcc $idx "If you want a short introduction to this tcl, use '.greethelp guide'"
  putdcc $idx "You can get help on individual commands: '.greethelp <command>'"
  return 0
  }
if {[string match ".*" $arg]} { set arg "[string trimleft $arg .]" }
if {[string match "set *" $arg]} { set arg "[lindex $arg 1]" }
greet:putlog "#$handle# greethelp $arg"
if {$arg == "delay" || $arg == "greet(delay)" || $arg == "\$greet(delay)"} {
  foreach line [greet:gethelp delay] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(floodprotect)" || $arg == "floodprotect" || $arg == "\$greet(floodprotect)"} {
  foreach line [greet:gethelp floodprotect] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(noresponse)" || $arg == "noresponse" || $arg == "\$greet(norespnse)"} {
  foreach line [greet:gethelp noresponse] { putdcc $idx $line }  
  return 1
  }
if {$arg == "greet(dir)" || $arg == "dir" || $arg == "\$greet(dir)"} {
  foreach line [greet:gethelp dir] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(how)" || $arg == "how" || $arg == "\$greet(how)"} {
  foreach line [greet:gethelp how] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(all)" || $arg == "all" || $arg == "\$greet(all)"} {
  foreach line [greet:gethelp all] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(max)" || $arg == "max" || $arg == "\$greet(max)"} {
  foreach line [greet:gethelp max] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(nicks)" || $arg == "nicks" || $arg == "\$greet(nicks)"} {
  foreach line [greet:gethelp nicks] { putdcc $idx $line }
  return 1
  }
if {$arg == "greet(data)" ||  $arg == "data" || $arg == "\$greet(data)"} {
  foreach line [greet:gethelp data] { putdcc $idx $line }
  return 1
  }
switch -exact $arg {
  "greetreset" {
     foreach line [greet:gethelp greetreset] { putdcc $idx $line }
     return 1
     }
  "+greetnick" {
     foreach line [greet:gethelp +greetnick] { putdcc $idx $line }
     return 1
     }
  "-greetnick" {
    foreach line [greet:gethelp -greetnick] { putdcc $idx $line }
    return 1
    }
  "greetnickview" {
    foreach line [greet:gethelp greetnickview] { putdcc $idx $line }
    return 1
    }
  "+greet" {
    foreach line [greet:gethelp +greet] { putdcc $idx $line }
    return 1
    }
  "-greet" {
    foreach line [greet:gethelp -greet] { putdcc $idx $line }
    return 1
    }
  "greetview" {
    foreach line [greet:gethelp greetview] { putdcc $idx $line }
    return 1
    }
  "greet" {
    foreach line [greet:gethelp greet] { putdcc $idx $line }
    return 1
    }
  "greetwho" {
    foreach line [greet:gethelp greetwho] { putdcc $idx $line }
    return 1
    }
  "greethow" {
    foreach line [greet:gethelp greethow] { putdcc $idx $line }
    return 1
    }
  "gmotd" { 
    foreach line [greet:gethelp gmotd] { putdcc $idx $line }
    return 1
    }
  "guide" {
    foreach line [greet:gethelp guide] { putdcc $idx $line }
    putdcc $idx "HINT: You can add up to $greet(max) lines for a greet, but just 1 line for a nickgreet."
    return 1
    }
  "+greetfile" {
    foreach line [greet:gethelp +greetfile] { putdcc $idx $line }  
    return 1
    }
  "+greethost" {
    foreach line [greet:gethelp +greethost] { putdcc $idx $line }
    return 1
    }
  "-greethost" {
    foreach line [greet:gethelp -greethost] { putdcc $idx $line }
    return 1
    }
  "greetmove" {
    foreach line [greet:gethelp greetmove] { putdcc $idx $line }
    return 1
    }
  "greetrandom" {
    foreach line [greet:gethelp greetrandom] { putdcc $idx $line }
    return 1
    }
  }
putdcc $idx "No help available on that."
return 1
}

proc dcc:greetrandom { handle idx arg } {
global greet greetrand
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greetrandom \[channel\] \[+flag\] <on/off>"
  return 0
  }
if {[string match "#*" [lindex $arg 0]]} {
  if {[string match "+*" [lindex $arg 1]]} {
    if {[llength $arg] < 3} {
      putdcc $idx "Usage: .greetrandom \[channel\] \[+flag\] <on/off>"
      return 0
      }
    set greetchan [lindex $arg 0]
    set greetflag [lindex $arg 1]
    set greetwhat [lindex $arg 2]
    } {
    set greetchan [lindex $arg 0]
    if {[llength $arg] < 2} {
      putdcc $idx "Usage: .greetrandom \[channel\] \[+flag\] <on/off>"
      return 0
      }
    set greetwhat [lindex $arg 1]
    }
  } {
  if {[string match "+*" [lindex $arg 0]]} {
    set greetflag [lindex $arg 0]
    if {[llength $arg] < 2} {
      putdcc $idx "Usage: .greetrandom \[channel\] \[+flag\] <on/off>"
      return 0
      }
    set greetwhat [lindex $arg 1]
    } {
    set greetwhat [lindex $arg 0]
    }
  set greetchan [lindex [console $idx] 0]
  }
if {[info exists greetflag] && [string length $greetflag] > 2} {
  putdcc $idx "Only 1 flag is allowed, e.g. .greetrandom +n on"
  return 0
  }
if {[info exists greetflag] && [lsearch -exact [split "abcdefghijklmnopqrstuvwxyz1234567890" ""] [stl [string trimleft $greetflag +]]] == -1} {
  putdcc $idx "$greetflag is no valid flag."
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {![validchan $greetchan]} {
  putdcc $idx "I'm not on $greetchan."
  return 0
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]] && ![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
  putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan."
  return 0
  }
if {[stl $greetwhat] != "on" && [stl $greetwhat] != "off"} {
  putdcc $idx "Usage: .greetrandom \[channel\] \[+flag\] <on/off>"
  return 0
  }
if {[info exists greetflag]} {
  greet:putlog "#$handle# greetrandom $greetchan ($greetflag) $greetwhat"
  set greetrand($greetflag-[stl $greetchan]) $greetwhat
  greet:save greetrand($greetflag-[stl $greetchan]) $greetwhat
  putdcc $idx "Random greets on $greetchan for $greetflag users are now \"[string toupper $greetwhat]\"."
  } {
  greet:putlog "#$handle# greetrandom $greetchan $greetwhat"
  set greetrand([stl $greetchan]) $greetwhat
  greet:save greetrand([stl $greetchan]) $greetwhat
  putdcc $idx "Random greets on $greetchan are now \"[string toupper $greetwhat]\"."
  }
return 1
}

proc dcc:greetmove { handle idx arg } {
global greet
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greetmove \[channel\] \[+flag\] <from> <to>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .greetmove \[channel\] \[+flag\] <from> <to>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set to [lindex $arg 3]
    set from [lindex $arg 2]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set to [lindex $arg 2]
    set from [lindex $arg 1]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {
    set from [lindex $arg 1]
    set to [lindex $arg 2]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set from [lindex $arg 0]
    set to [lindex $arg 1]
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. .greetmove +n <from> <to>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$from == "" || $to == ""} {
  putdcc $idx "Usage: .greetmove \[channel\] \[+flag\] <from> <to>"
  return 0
  }
if {$greetflags != ""} {
  set validflags "abcdefghijklmnopqrstuvwxyz1234567890"
  if {[lsearch -exact [split $validflags ""] [stl [string trimleft $greetflags +]]] == -1} {
    putdcc $idx "ERROR: $greetflags is no valid flag."
    return 0
    }
  greet:putlog "#$handle# greetmove ($greetchan) ($greetflags) $from -> $to"
  } {
  greet:putlog "#$handle# greetmove ($greetchan) $from -> $to"
  }
set tmp [greet:getfile $greet(dir)/channels/[stl [string trimleft $greetchan #]].dat]
set count 0
if {$greetflags == ""} { foreach line $tmp { if {![string match "+? *" $line]} { if {$line != ""} { incr count } } }
  } {
  foreach line $tmp { if {[string match "$greetflags *" $line]} { if {$line != ""} { if {[string match "$greetflags *" $line]} { incr count } } } } } 
if {$from > $count || $to > $count} {
  putdcc $idx "Error: Not so many lines on $greetchan."
  return 0
  }
if {$from == 0 || $to == 0} {
  putdcc $idx "Can't move from or to 0!"
  return 0
  }
if {$from == $to} {
  putdcc $idx "Yeah - moving from one point to the same rulezzz ;)"
  putdcc $idx "I think, you need (psychiatric) .help :))"
  return 0
  }
set countf 0
if {$greetflags == ""} {
  foreach line $tmp {
    if {![string match "+*" $line]} {
      incr countf
      if {$countf != $from} { lappend tmp2 $line } { set insert $line }
      }
    }
  } {
  foreach line $tmp {
    if {[string match "$greetflags *" $line]} {
      incr countf
      if {$countf != $from} { lappend tmp2 $line } { set insert $line }
      }
    }
  }
if {![info exists insert]} {
  putdcc $idx "Error: Can't move from $from."
  return 0
  }
set countf 0
if {$greetflags == ""} {
  foreach line $tmp2 {
    if {![string match "+? *" $line]} {
      incr countf
      if {$from < $to} {
        lappend tmp3 $line
	if {$countf == [expr {$to - 1}]} { lappend tmp3 $insert }
	} {  
        if {$countf == $to} { lappend tmp3 $insert }
        lappend tmp3 $line 
	}
      }
    }
  } {
  foreach line $tmp2 {
    if {[string match "$greetflags *" $line]} {
      incr countf
      if {$countf == $to} { lappend tmp3 $insert }
      lappend tmp3 $line
      }
    }
  }
set tmp [greet:getfile $greet(dir)/channels/[stl [string trimleft $greetchan #]].dat]
if {$greetflags == ""} {
  foreach line $tmp { if {[string match "+*" $line]} { lappend newfile $line } }
  } {
  foreach line $tmp { if {![string match "$greetflags *" $line]} { lappend newfile $line } }
  }
set file [open $greet(dir)/channels/[stl [string trimleft $greetchan #]].dat w]
if {[info exists newfile]} { foreach line $newfile { puts $file $line } }
foreach line $tmp3 { puts $file $line }
close $file
if {$greetflags == ""} {
  putdcc $idx "Moved line \"$from\" to line \"$to\" on $greetchan."
  } {
  putdcc $idx "Moved line \"$from\" to line \"$to\" for $greetflags users on $greetchan."
  }
return 1  
}

proc dcc:greetnickview { handle idx arg } {
global greet nickgreets
greet:putlog "#$handle# greetnickview"
if {![file exists $greet(dir)/$greet(nicks)]} {
  putdcc $idx "No nick greets saved."
  return 0
  }
set file [open $greet(dir)/$greet(nicks) r]
while {![eof $file]} {
  set line [gets $file]
  if {[llength $line] > 1} {
    set nick [lindex $line 0]
    set how [lindex $line 1]
    set text [greet:lend 2 $line]
    lappend tmp "  $nick ($how): $text"
    }
  }
if {![info exists tmp]} {
  putdcc $idx "No nick greets saved."
  return 0
  } {
  putdcc $idx "Showing nick greets:"
  set nickgreets $tmp
  foreach line $tmp {
    putdcc $idx " $line"
    }
  }  
return 1
}
 
proc dcc:greet { handle idx arg } {
global greet
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greet \[channel\] <on/off>"
  return 0
  }
set greetchan ""
set greetwhat ""
set greetflags ""
if {[string match "#*" $arg]} {
    set greetchan [stl [lindex $arg 0]]
    set greetwhat [greet:lend 1 $arg]
    if {![validchan $greetchan]} {
      putdcc $idx "ERROR: I'm not on $greetchan"
      return 0
      }
    } else {
    set greetwhat [stl $arg]
    set greetchan [stl [lindex [console $idx] 0]]
    }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
greet:putlog "#$handle# greet ($greetchan) $greetwhat"
if {$greetwhat == "on"} {
  greet:save greet($greetchan) 1
  set greet($greetchan) 1
  putdcc $idx "Greets for $greetchan are now enabled."
  return 0
  }
if {$greetwhat == "off"} {
  greet:save greet($greetchan) 0
  set greet($greetchan) 0
  putdcc $idx "Greets for $greetchan are now disabled."
  return 0
  }
putdcc $idx "Usage: .greet \[channel\] <on/off>"
return 1
}

proc dcc:greethow { handle idx arg } {
global greethow greet
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan"
    return 0
    }
  }
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greethow \[channel\] \[+flag\] <notice/msg>"
  return 0
  }
if {[string match "#*" $arg]} {
  set greetchan [lindex $arg 0]
  set greetwhat [lindex $arg 1]
  if {![validchan $greetchan]} {
    putdcc $idx "I'm not on $greetchan."
    return 0
    }
  if {[string match "+*" [lindex $arg 1]]} {
    if {[string length [lindex $arg 1]] != 2} {
      putdcc $idx "Only 1 flag is allowed."
      return 0
      } {
      set greetflag [string trimleft [lindex $arg 1] +]
      set greetwhat [lindex $arg 2]
      }
    }
  }
if {[string match "+*" $arg]} {
  if {[string length [lindex $arg 0]] != 2} {
    putdcc $idx "Only 1 flag is allowed."
    return 0
    } {
    set greetflag [string trimleft [lindex $arg 0] +]
    set greetwhat [lindex $arg 1]
    set greetchan [stl [lindex [console $idx] 0]]
    if {$greetchan == "*"} {
      putdcc $idx "Your console channel is invalid."
      return 0
      }
    }
  }
if {![string match "+*" $arg] && ![string match "#*" $arg]} {
  set greetchan [stl [lindex [console $idx] 0]]
  if {$greetchan == "*"} {
    putdcc $idx "Your console channel is invalid."
    return 0
    }
  set greetwhat "[stl $arg]"
  }
if {[stl $greetwhat] == "primvsg" || [stl $greetwhat] == "msg"} {
  set greetwhat "privmsg"
  } {
  if {[stl $greetwhat] == "notice"} {
    set greetwhat "notice"
    } {
    putdcc $idx "Don't know how to greet via \"$greetwhat\"."  
    return 0
    }
  } 
if {[info exists greetflag]} {
  greet:putlog "#$handle# greethow $greetchan (+$greetflag) $greetwhat"
  } {
  greet:putlog "#$handle# greethow $greetchan $greetwhat"
  }
if {[info exists greetchan]} {
  if {[info exists greetflag]} {
    if {$greetwhat == "notice"} {
      greet:save greethow(+$greetflag-[stl $greetchan]) NOTICE 
      set greethow(+$greetflag-[stl $greetchan]) NOTICE
      putdcc $idx "Now greeting +$greetflag users on $greetchan via \"NOTICE\"."
      return 1
      }
    if {$greetwhat == "privmsg" || $greetwhat == "msg"} {
      greet:save greethow(+$greetflag-[stl $greetchan]) PRIVMSG 
      set greethow(+$greetflag-[stl $greetchan]) PRIVMSG
      putdcc $idx "Now greeting +$greetflag users on $greetchan via \"PRIVMSG\"."
      return 1
      }
    }
  if {$greetwhat == "notice"} {
    greet:save greethow([stl $greetchan]) NOTICE
    putdcc $idx "Now greeting users on $greetchan via \"NOTICE\"."
    set greethow([stl $greetchan]) NOTICE
    return 1
    }
  if {$greetwhat == "privmsg" || $greetwhat == "msg"} {
    greet:save greethow([stl $greetchan]) PRIVMSG
    set greethow([stl $greetchan]) PRIVMSG
    putdcc $idx "Now greeting users on $greetchan via \"PRIVMSG\""
    return 1
    }
  } 
}

proc dcc:greetwho { handle idx arg } {
global greet greetall
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greetwho \[channel\] <all/known/unkown>"
  return 0
  }
if {[string match "#*" $arg]} {
    set greetwhat [stl [greet:lend 1 $arg]]
    set greetchan [stl [lindex $arg 0]]
    if {![validchan $greetchan]} {
      putdcc $idx "ERROR: I'm not on $greetchan"
      return 0
      }
    } else {
    set greetwhat [lindex [stl $arg] 0] 
    set greetchan [stl [lindex [console $idx] 0]]
    if {$greetchan == "*"} {
      putdcc $idx "Your console channel is invalid."
      return 0
      }
    }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greetchan]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan"
    return 0
    }
  }
greet:putlog "#$handle# greetwho ($greetchan) $greetwhat"
if {$greetwhat == "all"} {
  set greetall($greetchan) 1
  greet:save greetall($greetchan) 1 
  putdcc $idx "Now showing greets on $greetchan to all users"
  return 0
  }
if {$greetwhat == "known"} {
  set greetall($greetchan) 1
  greet:save greetall($greetchan) 0 
  putdcc $idx "Now showing greets on $greetchan to only known users"
  return 0
  }  
if {$greetwhat == "unknown"} {
  set greetall($greetchan) 2
  greet:save greetall($greetchan) 2
  putdcc $idx "Now showing greets on $greetchan to only unknown users"
  return 0
  }
putdcc $idx "Usage: .greetwho \[channel\] <all/known/unknown>"
}

proc dcc:greetview { handle idx arg } {
global greet changreets greetrand
if {[llength $arg] < 1} {
  set chan [stl [lindex [console $idx] 0]]
  if {$chan == "*"} {
    putdcc $idx "Your console channel is invalid."
    return 0
    } 
  } else {
  set chan [stl [lindex $arg 0]]
  }
if {![validchan $chan]} {
  putdcc $idx "ERROR: I'm not on $chan"
  return 0
  }
greet:putlog "#$handle# ($chan) greetview"
set greetload "$greet(dir)/channels/[stl [string trimleft $chan #]].dat"
set greetchan [greet:load greet([stl $chan])]
set greetallchan [greet:load greetall([stl $chan])]
set greethowchan [greet:load greethow([stl $chan])]
# this is for older version, which can produce some bugs :-/
if {[lsearch -exact "NOTICE PRIVMSG MSG" [string toupper $greethowchan]] == "-1"} { 
  set greethowchan $greet(how)
  greet:save greethow([stl $chan]) $greet(how)
  }
if {[lsearch "1 2 0" $greetallchan] == "-1"} {
  set greetallchan $greet(all)
  greet:save greetall([stl $chan]) $greet(all)
  } 
switch -exact $greetallchan {
  "1" { set c "all" }
  "0" { set c "known" }
  "2" { set c "unknown" }
  }
putdcc $idx "DISPLAYING GREETS FOR [string toupper $chan]:"
if {[greet:load greet([stl $chan])] == 0} {
  putdcc $idx " "
  putdcc $idx "Greets are currently DISABLED!"
  putdcc $idx "(use: 'greet $chan on' to enable)"
  }
if {![file exists $greetload]} {
  set file [open $greetload w]
  close $file
  }
set greetstore ""
set file [open $greetload r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    lappend greetstore $line
    }
  }
close $file
set greeta ""
set greetb ""
foreach line $greetstore {
  if {[string match "+*" $line]} {
    lappend greetflag([lindex $line 0]) "[greet:lend 1 $line]"
    if {[lsearch -exact $greeta [lindex $line 0]] == -1} {
      append greeta "[lindex $line 0] "
      }
    } else {
    lappend greetb $line
    }
  }
set tmp 0
if {$greeta != ""} {
  set tmp 1
  foreach flag $greeta {
    set greethow($flag) [greet:load greethow([string trimleft $flag +])([stl $chan])]
    if {$greethow($flag) != ""} {
      set greethw $greethow($flag)
      } {
      set greethw $greethowchan
      }
    putdcc $idx " "
    if {[info exists greetrand($flag-[stl $chan])] && $greetrand($flag-[stl $chan]) == "on"} { 
      putdcc $idx "Random greets for [string toupper [greet:flag2norm user $flag]] via $greethw:"
      } {
      putdcc $idx "Greets for [string toupper [greet:flag2norm user $flag]] via $greethw:"
      }
    foreach line $greetflag($flag) {
      putdcc $idx "  $line"
      }
    }
  }
if {$greetb != ""} {
  set tmp 1
  putdcc $idx " "
  if {[info exists greetrand([stl $chan])] && $greetrand([stl $chan]) == "on"} {
    putdcc $idx "Random greets for [string toupper $c] users via $greethowchan:"
    } {
    putdcc $idx "Greets for [string toupper $c] users via $greethowchan:"
    }
  foreach line $greetb {
    putdcc $idx "  $line"
    }
  }
if {$tmp == 0} {
  putdcc $idx " "
  putdcc $idx "There are currently no chan-greets saved for $chan."
  putdcc $idx "(use .+greet $chan \[+flag\] <greet>)"
  }
set hostsgreets [greet:getfile $greet(dir)/channels/[string trimleft $chan #].host]
if {$hostsgreets != ""} {
  foreach line $hostsgreets { lappend tmp2 [lindex $line 0] }
  set cl [greet:sl $tmp2]
  putdcc $idx " "
  putdcc $idx "Hostmask greets via $greethowchan:"
  putdcc $idx "  [format "%-${cl}s   " Hostmask] Greet"
  foreach line $hostsgreets { 
    putdcc $idx "  [format "%-${cl}s   " [lindex $line 0]] [lrange $line 1 end]"
    }
  } {
  putdcc $idx " "
  putdcc $idx "There are currently no host-greets saved."
  putdcc $idx "(use .+greethost $chan <nick!ident@host> <greet>)"
  }
set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft $chan #].dat]
set hostgreets([stl $chan]) $hostsgreets
return 1
}

proc dcc:+greetfile { handle idx arg } {
global greet changreets files-path
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .+greetfile \[channel\] \[+flag\] <filename>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .+greetfile \[channel\] \[+flag\] <filename>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 1 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. +greetfile +n <filename>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greethow == ""} {
  putdcc $idx "Usage: .+greetfile \[channel\] \[+flag\] <filename>"
  return 0
  }
if {[string match "/*" $greethow] || [string match "*..*" $greethow]} {
  putdcc $idx "ERROR: Only files, which are saved in the filearea are allowed."
  return 0
  }
if {![string match "*/" ${files-path}]} { append files-path "/" } 
if {![file exists ${files-path}$greethow]} {
  putdcc $idx "ERROR: No such file in the filearea: $greethow."
  return 0
  }
if {![file readable ${files-path}$greethow]} {
  putdcc $idx "ERROR: can't read file: $greethow (check permissions)"
  return 0
  }
set validflags "abcdefghijklmnopqrstuvwxyz1234567890"
if {$greetflags != "" && [lsearch -exact [split $validflags ""] [stl [string trimleft $greetflags +]]] == -1} {
  putdcc $idx "ERROR: $greetflags is no valid flag."
  return 0
  }
if {$greetflags != ""} {
  greet:putlog "#$handle# +greetfile ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# +greetfile ($greetchan) $greethow"
  }
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
set file [open $greetsave r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    if {[string match "+*" $line]} {
      if {![info exists count([lindex $line 0])]} {
	set count([lindex $line 0]) 1
	} {
	incr count([lindex $line 0])
	}
     } {
     if {![info exists count(all)]} {
       set count(all) 1
       } {
       incr count(all)
       }
     }
   }   
 }
close $file 
if {$greetflags == ""} { 
  if {[info exists count(all)]} { set rcount $count(all) } { set rcount 0 }
  } { 
  if {[info exists count($greetflags)]} { set rcount $count($greetflags) } { set rcount 0 }
  }
if {[greet:ispermown $handle]} {
  set index [greet:getfile ${files-path}$greethow]
  set lcount 0
  set file [open $greetsave a+]
  foreach line $index {
    incr lcount
    if {$greetflags == ""} {
      puts $file $line
      } {
      puts $file "$greetflags $line"
      }
    }  
  close $file
  if {$greetflags == ""} {
    putdcc $idx "Added $lcount lines from \"$greethow\" for $greetchan."
    } {
    putdcc $idx "Added $lcount lines from \"$grethow\" for $greetflags users on $gretchan."
    }
  return 0
  }
if {$rcount >= $greet(max)} {
  if {$greetflags == ""} {
    putdcc $idx "No more lines allowed for greets on $greetchan."
    } {
    putdcc $idx "No more lines allowed for greets on $greetchan for $greetflags users."
    }
  return 0
  }
set index [greet:getfile ${files-path}$greethow]
set file [open $greetsave a+]
foreach line $index {
  if {$rcount >= $greet(max)} {
    if {$greetflags == ""} {
      putdcc $idx "No more lines allowed for greets on $greetchan."
      } {
      putdcc $idx "No more lines allowed for $greetflags greets on $greetchan."
      }
    putdcc $idx "Added $rcount lines of \"$greethow\"."  
    close $file
    return 0
    }
  incr rcount
  if {$greetflags == ""} {
    puts $file $line
    } {
    puts $file "$greetflags $line"
    }
  }  
close $file
if {$greetflags == ""} {
  putdcc $idx "Added \"$greethow\" for greets on $greetchan. ($rcount lines)"
  } {
  putdcc $idx "Added \"$greethow\" for $greetflags greets on $greetchan. ($rcount lines)"
  }
return 1
}

proc dcc:-greethost { handle idx arg } {
global greet hostgreets
if {[llength $arg] < 2} {
  putdcc $idx "Usage: .-greethost \[channel\] <nick!ident@host> <greet>"
  return 0
  }
if {[string match "#*" $arg]} {
  set chan [lindex $arg 0]
  if {![validchan $chan]} {
    putdcc $idx "I'm not on $chan."
    return 0
    }
  set hostmask [lindex $arg 1]
  set greettxt [greet:lend 2 $arg]
  } {
  set chan [lindex [console $idx] 0]
  set hostmask [lindex $arg 0]
  set greettxt [greet:lend 1 $arg]
  }
if {[llength $greettxt] < 1} {
  putdcc $idx "Usage: .+greethost \[channel\] <nick!ident@host> <greet>"
  return 0
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]] && ![matchattr $handle |[lindex [split $greet(rbind) |] 1] $chan]} {
  putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $chan."
  return 0
  }
if {[string length $hostmask] < 8} {
  putdcc $idx "Please use a longer hostmask. (at least 8 characters)."
  return 0
  }
set hostgreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
if {![file exists $greet(dir)/channels/[string trimleft [stl $chan] #].host]} {
  set file [open $greet(dir)/channels/[string trimleft [stl $chan] #].host w]
  close $file
  putdcc $idx "There are currently no hostmask greets saved on $chan."
  }
foreach line $hostgreets([stl $chan]) {
  if {[string match "$hostmask $greettxt" $line]} {
    set tmp 1
    } {
    lappend blubb $line
    }
  }
if {[info exists tmp]} {
  greet:putlog "#$handle# -greethost ($chan) $hostmask $greettxt"
  putdcc $idx "Deleted \"$greettxt\" ($hostmask) on $chan."
  set file [open $greet(dir)/channels/[string trimleft [stl $chan] #].host w]
  if {![info exists blubb]} { close $file } {
  foreach line $blubb {
    puts $file $line
    }
  close $file
  }
  } {
  putdcc $idx "Can't find \"$greettxt\" ($hostmask) on $chan."
  }
set hostgreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
return 1
}  

proc dcc:+greethost { handle idx arg } {
global greet hostgreets
if {[llength $arg] < 2} {
  putdcc $idx "Usage: .+greethost \[channel\] <nick!ident@host> <greet>"
  return 0
  }
if {[string match "#*" $arg]} {
  set chan [lindex $arg 0]
  if {![validchan $chan]} {
    putdcc $idx "I'm not on $chan."
    return 0
    }
  set hostmask [lindex $arg 1]
  set greettxt [greet:lend 2 $arg]
  } {
  set chan [lindex [console $idx] 0]
  set hostmask [lindex $arg 0]
  set greettxt [greet:lend 1 $arg]
  }
if {[llength $greettxt] < 1} {
  putdcc $idx "Usage: .+greethost \[channel\] <nick!ident@host> <greet>"
  return 0
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]] && ![matchattr $handle |[lindex [split $greet(rbind) |] 1] $chan]} {
  putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $chan."
  return 0
  }
if {[string length $hostmask] < 8} {
  putdcc $idx "Please use a longer hostmask. (at least 8 characters)."
  return 0
  }
if {![string match "*@*.*" $hostmask]} {
  putdcc $idx "Not a valid hostmask: $hostmask (use this format: nickname!ident@host.domain)"
  putdcc $idx "Wildcards (* and ?) are allowed."
  return 0
  }
if {![file exists $greet(dir)/channels/[string trimleft [stl $chan] #].host]} {
  set file [open $greet(dir)/channels/[string trimleft [stl $chan] #].host w]
  close $file
  set hfile ""
  } {
  set hfile [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
  }
set count 0
foreach line $hfile {
  incr count
  }
if {$count >= $greet(max)} {
  putdcc $idx "No more lines are allowed for hostmask greets on $chan."
  set hostgreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
  return 0
  }
set file [open $greet(dir)/channels/[string trimleft [stl $chan] #].host a+]
puts $file "$hostmask $greettxt"
close $file
greet:putlog "#$handle# +greethost ($chan) $hostmask $greettxt"
putdcc $idx "Added \"$greettxt\" for hostmask $hostmask on $chan."
set hostgreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].host]
return 1
}
  
proc dcc:+greet { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .+greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .+greet \[channel\] \[+flag\] <greet>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 1 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {  
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. +greet +n <greet>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greethow == ""} {
  putdcc $idx "Usage: .+greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {$greetflags != ""} {
  set validflags "abcdefghijklmnopqrstuvwxyz1234567890"
  if {[lsearch -exact [split $validflags ""] [stl [string trimleft $greetflags +]]] == -1} {
    putdcc $idx "ERROR: $greetflags is no valid flag."
    return 0
    }
  greet:putlog "#$handle# +greet ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# +greet ($greetchan) $greethow"
  }
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
set count 0
if {[file exists $greetsave]} {
  set file [open $greetsave r]
  while {![eof $file]} {
    set line [gets $file]
    if {$line != ""} { if {$greetflags != ""} { if {[string match "$greetflags *" $line]} { incr count } } { if {![string match "+*" $line]} { incr count } } } } 
  close $file
  } {
  set file [open $greetsave w]
  if {$greetflags == ""} {
    puts $file $greethow 
    } { 
    puts $file "$greetflags $greethow"
    }
  close $file
  }
if {$count >= $greet(max)} { putdcc $idx "ERROR: Only $greet(max) lines are allowed for greets." ; return 0 }
set file [open $greetsave a+]
if {$greetflags == ""} { 
  puts $file $greethow
  } else {
  puts $file "$greetflags $greethow"
  }
close $file
if {$greetflags != ""} {
  putdcc $idx "Added \"$greethow\" ($greetflags users) for $greetchan."
  } else {
  putdcc $idx "Added \"$greethow\" for $greetchan."
  }
set changreets([stl $greetchan]) ""
set file [open $greetsave r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    lappend changreets([stl $greetchan]) $line
    }
  }
close $file
}

bind bot - sg_info bot:sginfo
proc bot:sginfo { bot com arg } {
global greet
putbot $bot "gw_version $greet(version)"
}

proc dcc:-greet { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .-greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .-greet \[channel\] \[+flag\] <greet>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 1 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle [lindex [split $greet(rbind) |] 0]]} {
  if {![matchattr $handle |[lindex [split $greet(rbind) |] 1] $greet(chan)]} {
    putdcc $idx "Sorry, you don't have +[lindex [split $greet(rbind) |] 1] on $greetchan."
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. -greet +n <greet>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greetflags != ""} {
  set validflags "abcdefghijklmnopqrstuvwxyz1234567890"
  if {[lsearch -exact [split $validflags ""] [stl [string trimleft $greetflags +]]] == -1} { putdcc $idx "ERROR: $greetflags is no valid flag." ; return 0 }
  greet:putlog "#$handle# -greet ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# -greet ($greetchan) $greethow"
  }
set greetnew ""
set greetfound 0
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
if {![file exists $greetsave]} { 
  set file [open $greetsave w]
  close $file
  putdcc $idx "ERROR: No greets saved for $greetchan"
  return 0
  }
set file [open $greetsave r] 
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    if {$greetflags != ""} {
      if {[string match "$greetflags $greethow*" $line]} {
        set greetfound 1
	} {
	lappend greetnew $line
	}
      } {
      if {[string match "$greethow*" $line] && ![string match "+? *" $line]} { 
        set greetfound 1 
	} { 
	lappend greetnew $line
	}
      }
    }
  }
close $file
if {$greetfound == 0} { putdcc $idx "Can't find $greethow for $greetchan." ; return 0 }
if {[llength $greetnew] < 1} {
  set file [open $greetsave w]
  close $file
  putdcc $idx "Deleted greets for $greetchan" 
  set changreets([stl $greetchan]) "" 
  return 0
  }
set file [open $greetsave w]
foreach line $greetnew { puts $file $line } 
close $file
set changreets([stl $greetchan]) ""
set file [open $greetsave r]
while {![eof $file]} { if {[llength [gets $file]] > 1} { lappend changreets([stl $greetchan]) [gets $file] } }
close $file
putdcc $idx "Deleted \"$greethow\" for $greetchan."
}

proc greet:replace { nick chan line } {
global botnick
if {[string match "*greet-nick*" $line]} { regsub -all greet-nick $line $nick line }
if {[string match "*greet-chan*" $line]} { regsub -all greet-chan $line $chan line }
if {[string match "*greet-botnick*" $line]} { regsub -all greet-botnick $line $botnick line }
return $line
}

proc greet:queue { chan } {
global que greet
if {$greet(delay) == 0} { return 0 }
if {![info exists que($chan)]} { set que($chan) 1 ; utimer $greet(delay) "greet:unset $chan" ; return 0 } { return 1 }
}

proc greet:unset { chan } {
global que
if {[info exists que($chan)]} { unset que($chan) }
}

bind join -|- *!*@* greet:join
proc greet:join { nick uhost handle chan } {
global gqu greet botnick nickgreets changreets greetflood hostgreets greethow greetall greetrand
if {$nick == $botnick || [matchattr $handle b]} { return 0 }
set realchan $chan
set chan [stl $chan]
if {![info exists changreets($chan)]} { 
  if {![file exists $greet(dir)/channels/[string trimleft $chan #].dat]} {
    putlog "GreetWondeR $greet(version) Can't find channelfile for $realchan: created."
    set file [open $greet(dir)/channels/[string trimleft $chan #].dat w]
    close $file 
    set changreets($chan) ""
    } {
    set changreets($chan) [greet:getfile $greet(dir)/channels/[string trimleft $chan #].dat]
    }
  }  
# just some possible error handlings...shouldn't be activated, but who knows =)
if {![info exists nickgreets]} { set nickgreets [greet:load $greet(dir)/$greet(nicks)] }
if {![info exists hostgreets($chan)]} {
  set hostgreets($chan) [greet:getfile greet(dir)/channels/[string trimleft $chan #].host]
  }
if {$changreets($chan) == "" && $hostgreets($chan) == "" && $nickgreets == ""} {
  return 0
  }
if {[info exists greetflood($chan)]} { return 0 }
if {$greet($chan) == 0} { return 0 }
if {$handle != "*" && $nickgreets != ""} {
  foreach line $nickgreets {    
    if {[string match "$handle *" $line]} {
      set how "[string toupper [lindex $line 1]]"
      set text "[greet:replace $nick $realchan [greet:lend 2 $line]]"
      switch -exact $how {
        "PUBLIC" {
          if {[greet:queue $chan]} { return 0 } 
          puthelp "PRIVMSG $chan :$text" ; return 0
          }
        "NOTICE" {
          if {[greet:queue $chan]} { return 0 }
          puthelp "NOTICE $nick :$text" ; return 0
          }
        "PRIVMSG" {
          if {[greet:queue $chan]} { return 0 }
          puthelp "PRIVMSG $nick :$text" ; return 0
          }
        "ACTION" {  
          if {[greet:queue $chan]} { return 0 }
          puthelp "PRIVMSG $chan :\001ACTION $text\001" ; return 0
          }
	}  
      }
    }
  }
if {$hostgreets($chan) != ""} {
  foreach line $hostgreets($chan) {
    if {[string match "[stl [lindex $line 0]]" "[stl $nick!$uhost]"]} {
      set matched 1
      }
    }
  if {[info exists matched]} { if {[greet:queue $chan]} { return 0 } }
  foreach line $hostgreets($chan) {
    if {[string match "[stl [lindex $line 0]]" "[stl $nick!$uhost]"]} {
      set greethost 1
      puthelp "$greethow($chan) $chan :[greet:replace $nick $realchan [greet:lend 1 $line]]"
      }
    }
  if {[info exists greethost]} { return 0 }
  }  
set greeta ""
if {$changreets($chan) == ""} { return 0 } 
foreach line $changreets($chan) { lappend greetstore $line }
foreach line $greetstore {
  if {[string match "+*" $line]} {
    lappend greetflag([lindex $line 0]) [greet:lend 1 $line]
    if {[lsearch -exact $greeta [lindex $line 0]] == -1} { append greeta "[lindex $line 0] " }
    } { lappend greetb $line }
  }
if {$greeta != ""} {
  foreach flag $greeta {
    if {[matchattr $handle $flag] || [matchattr $handle |$flag $chan]} {
      if {![info exists greethow($flag-$chan)]} {
	set greethow($flag-$chan) "$greethow($chan)"
	}
      if {$greethow($flag-$chan) == ""} { set greethow($flag-$chan) $greethow($chan) }
      if {[greet:queue $chan]} { return 0 }
      if {[info exists greetrand($flag-$chan)] && $greetrand($flag-$chan) == "on"} {
	puthelp "$greethow($flag-$chan) $nick :[greet:replace $nick $realchan [lindex $greetflag($flag) [rand [expr {[llength $greetflag($flag)] - 1}]]]]"
	return 0
	}
      foreach line $greetflag($flag) {
	puthelp "$greethow($flag-$chan) $nick :[greet:replace $nick $realchan $line]"
        }
      return 0
      }
    }
  }
if {$greetall($chan) == 0 && $handle == "*"} { return 0 }
if {$greetall($chan) == 2 && $handle != "*"} { return 0 }
if {[info exists greetb]} {
  if {[greet:queue $chan]} { return 0 }
  if {[info exists greetrand($chan)] && $greetrand($chan) == "on"} {
    puthelp "$greethow($chan) $nick :[greet:replace $nick $realchan [lindex $greetb [rand [expr {[llength $greetb] - 1}]]]]"
    return 0
    }
  foreach line $greetb {
    puthelp "$greethow($chan) $nick :[greet:replace $nick $realchan $line]"
    }
  return 0
  }
}

greet:init start - 
